#include <assert.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include <unistd.h>
#include <stdio.h>
#include <math.h>
#include <time.h>

#include "board.h"
#include "driver.h"
#include "clock_face.h"
#include "fonts.h"
#include "framebuffer.h"

uint16_t image[240 * 240];

int main(void)
{
    drv_open(&lcd_drv);

    double min_len = 80;
    double std_len = 60;
    double root_x = 120;
    double root_y = 120;
    double min_angle = 90;
    double std_angle = 90;
    double dest_x;
    double dest_y;

    time_t T;
    struct  tm tm;

    while(1) {
        fb_load_image(image, clock_face, 240 * 240);

        // just to shown image orientation
        fb_draw_line(image, 10, 10, 12, 12, 0x00f8);
        fb_draw_line(image, 10, 11, 12, 12, 0x00f8);
        fb_draw_line(image, 10, 12, 12, 12, 0x00f8);

        T = time(NULL);
        tm = *localtime(&T);

        // date frame
        fb_draw_line(image, 158, 108, 183, 108, 0xffff);
        fb_draw_line(image, 158, 108, 158, 127, 0xffff);
        fb_draw_line(image, 183, 108, 183, 127, 0xffff);
        fb_draw_line(image, 158, 127, 183, 127, 0xffff);

        // date - day
        char date_str[3] = {'\0', '\0', '\0'};
        snprintf(date_str, 3, "%d", tm.tm_mday);
        fb_draw_string(image, 160, 112, date_str, &Font16, 0xffff);

        //  minute pointer
        min_angle = (360 / 60) * tm.tm_min + 270;
        if(min_angle >= 360.0) {
            min_angle -= 360.0;
        }

        dest_x = root_x + min_len * cos(min_angle * M_PI / 180);
        dest_y = root_y + min_len * sin(min_angle * M_PI / 180);
        fb_draw_line(image, (uint16_t)root_x, (uint16_t)root_y, (uint16_t)dest_x, (uint16_t)dest_y, 0xffff);

        // hour pointer
        std_angle = 0.5 * (60 * tm.tm_hour + tm.tm_min) + 270;
        if(std_angle >= 360.0) {
            std_angle -= 360.0;
        }

        dest_x = root_x + std_len * cos(std_angle * M_PI / 180);
        dest_y = root_y + std_len * sin(std_angle * M_PI / 180);
        fb_draw_line(image, (uint16_t)root_x, (uint16_t)root_y, (uint16_t)dest_x, (uint16_t)dest_y, 0xffff);

        drv_write(&lcd_drv, (const char *)image, 240 * 240);

        sleep(1);
    }

    drv_close(&lcd_drv);

    return 0;
}
